<?php

//
// innovaphone show outgoing fax calls PHP script
// copyright (c) innovaphone 2012 - 2014
//

$path=dirname(__FILE__);
require_once("$path/../app-classes/innovaphone.fax.config.class.php");
require_once("$path/../app-classes/innovaphone.pbx.info.class.php");
require_once("$path/../app-classes/innovaphone.pbx.class.php");
require_once("$path/../app-classes/innovaphone.fax.class.php");

$version = file_get_contents("$path/../version");

declare(ticks = 1);
?>

innovaphone show outgoing fax calls PHP script
copyright (c) innovaphone 2012 - 2014
<?php

print "Version " . $version . "\n\n";

$help = false;
foreach($argv as $arg) {
    if(in_array($arg, array('--help', '-help', '-h', '-?'))) {
        $help = true;
    }
}

if(!is_array($_GET) && ($argc < 2 || $help)) {
?>
    Usage:
    <?php echo $argv[0]; ?> <configuration id>

    <configuration id> is the configuration id specific for this server instance.
    With the --help, -help, -h, or -? options, you can get this help.

<?php
exit(1);
} 

$configurationId        = null;
if($argc >= 1) {
    $configurationId    = intval($argv[1]);
}
else if(is_array($_GET)) {
    $configurationId    = intval($_GET['id']);
}

$pbx    = null;

function terminateSession(&$pbx) {
    try {
        $p = $pbx->End($pbx->getSession());
    }
    catch(Exception $e) {
        return false;
    }
    return true;
}

function shutdown_function() {
    global $pbx;
    if($pbx && $pbx->getKey()) {
        terminateSession($pbx);
    }
    print "\n\n";
}

register_shutdown_function('shutdown_function');


print "Reading configuration... ";
$cfg     = new FaxServer();
$cfg->read("", $configurationId);
if(!$cfg) {
    print "failed.\n";
    die("Could not read configuration.");
}
print "done.\n";


do {
    $server     = $cfg->soapHost;
    $port       = $cfg->soapPort;
    $https      = $cfg->https;
    $httpu      = $cfg->soapUser;
    $httpp      = $cfg->soapPassword;
    $userName   = $cfg->soapFaxUser;
    $dynPbxId   = $cfg->soapDynPbx;
    $webdavUrl  = $cfg->webdavURL;

    print "Connecting to PBX " . $server . "... ";
    $pbx = new InnovaphonePBX(
        $server,
        $port,
        $https,
        $httpu,
        $httpp,
        $userName,
        "innovaphone PHP fax show [" . $version . "]",
        null,
        dirname(__FILE__) . '/../wsdl/pbx10_00.wsdl',
        $dynPbxId);
        
    if($pbx->getKey() == 0) {
        print "failed.\n";
        die("\nFailed to login to PBX: " . $pbx->getFaultString() . "\n");
    }
    print "connected.\n\n";

    $pbx->showVersion();
    print "\n";

    $userHandle = 0;

    try {
        $userHandle = $pbx->UserInitialize($pbx->getSession(), $userName, true, false, "");
    }
    catch(Exception $e) {
        print "Reconnecting...\n\n";
        continue;
    }
    if(!$userHandle) {
        die("Couldn't subscribe to user {$userName}.\n");
    }

    $fax = new InnovaphoneFax($pbx, $userName);
    $pbxInfo = &$fax;

    if(!$pbxInfo->initialize()) {
        continue;
    }

    $user = $pbxInfo->getUser($userName);
    if(!$user) {
        die("User is not in poll list.\n");
    }

    $fax->showOutgoingCalls($userHandle);
    $pbxInfo->showCalls();
    $pbxInfo->purge();

    do {
        try {
            $p = $pbx->Poll($pbx->getSession());
        }
        catch(Exception $e) {
            try {
                $p = $pbx->Echo($pbx->getSession(), $pbx->getKey());
            }
            catch(Exception $e) {
                $pbx = 0;
                die("Connection error: " . $e->faultstring . "\n");
            }
            if($p) {
                continue;
            }
            else {
                $pbx = 0;
                print "Reconnecting...\n\n";
                break;
            }
        }

        $pbxInfo->update($p);
        $fax->showOutgoingCalls($userHandle);
        $pbxInfo->showCalls();
        $pbxInfo->purge();

    } while(true);
    
} while(true);

?>